"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGObject subclass:#RGBehaviorStrategyUser
	instanceVariableNames:'behaviorStrategy'
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGBehaviorStrategyUser comment:'I am an abstract behavior that has a behavior strategy and and delegates all messages to it'
!

!RGBehaviorStrategyUser methodsFor:'accessing'!

baseClass: anRGClass

    ^ self behaviorStrategy baseClass: anRGClass
!

behaviorStrategy
    ^ behaviorStrategy
!

behaviorStrategy: anObject

    | needsInitialization |
    
    needsInitialization := behaviorStrategy isNil.
    behaviorStrategy := anObject.
    behaviorStrategy owner: self.
    needsInitialization ifTrue: [ 
        behaviorStrategy initializeUnresolved ].
    
!

instanceVariables: aCollectionOfSymbols

    ^ self behaviorStrategy instanceVariables: aCollectionOfSymbols
! !

!RGBehaviorStrategyUser methodsFor:'accessing - definition'!

definition

    ^ self behaviorStrategy definition
! !

!RGBehaviorStrategyUser methodsFor:'as yet unclassified'!

allSlots

    ^ self behaviorStrategy allSlots
!

baseClass

    ^ self behaviorStrategy baseClass
!

instSize

    ^ self behaviorStrategy instSize
!

instVarNames
    ^ self behaviorStrategy instVarNames
!

instanceSide

    ^ self behaviorStrategy instanceSide
!

theMetaClass

    ^ self behaviorStrategy theMetaClass
!

theNonMetaClass
    
    ^ self behaviorStrategy theNonMetaClass
! !

!RGBehaviorStrategyUser methodsFor:'printing'!

instanceVariablesString

    ^ self behaviorStrategy instanceVariablesString
!

storeOn: aStream 
    
    ^ self behaviorStrategy storeOn: aStream
! !

!RGBehaviorStrategyUser methodsFor:'queries - other'!

baseBehavior

    ^ self behaviorStrategy baseBehavior
! !

!RGBehaviorStrategyUser methodsFor:'queries - testing'!

isMeta
    "By default a non-meta class is considered"

    ^ self behaviorStrategy isMeta
! !

!RGBehaviorStrategyUser methodsFor:'resolving'!

makeResolved

    self behaviorStrategy makeResolved.
    super makeResolved.
! !

!RGBehaviorStrategyUser methodsFor:'strategy'!

addClassVariable: anRGInstanceVariableDefinition 

    ^ self behaviorStrategy addClassVariable: anRGInstanceVariableDefinition 
!

addSharedPool: anRGPoolVariable

    ^ self behaviorStrategy addSharedPool: anRGPoolVariable
!

allClassVarNames

    ^ self behaviorStrategy allClassVarNames
!

allClassVariables

    ^ self behaviorStrategy allClassVariables
!

baseTrait

    ^ self behaviorStrategy baseTrait
!

baseTrait: anRGClass

    ^ self behaviorStrategy baseTrait: anRGClass
!

bindingOf: varName

    ^ self behaviorStrategy bindingOf: varName
!

category

    ^ self behaviorStrategy category
!

category: aString

    ^ self behaviorStrategy category: aString
!

classSide

    ^ self behaviorStrategy classSide
!

classTrait

    ^ self behaviorStrategy classTrait
!

classTrait: anRGMetaclassTrait

    ^ self behaviorStrategy classTrait: anRGMetaclassTrait
!

classVarNames

    ^ self behaviorStrategy classVarNames
!

classVariableDefinitionString

    ^ self behaviorStrategy classVariableDefinitionString
!

classVariables

    ^ self behaviorStrategy classVariables
!

classVariables: aCollectionOfSymbols

    ^ self behaviorStrategy classVariables: aCollectionOfSymbols
!

classVariablesDo: aBlock

    ^ self behaviorStrategy classVariablesDo: aBlock
!

cleanClassVariables

    ^ self behaviorStrategy cleanClassVariables
!

cleanSharedPools

    ^ self behaviorStrategy cleanSharedPools
!

comment

    ^ self behaviorStrategy comment
!

comment: anRGComment

    ^ self behaviorStrategy comment: anRGComment
!

defaultMetaClass

    ^ self behaviorStrategy defaultMetaClass
!

innerBindingOf: aSymbol

    ^ self behaviorStrategy innerBindingOf: aSymbol
!

isTrait

    ^ self behaviorStrategy isTrait
!

layout

    ^ self behaviorStrategy layout
!

layout: anRGLayout

    ^ self behaviorStrategy layout: anRGLayout
!

package

    ^ self behaviorStrategy package
!

package: anRGPackage

    ^ self behaviorStrategy package: anRGPackage
!

referencedBehaviors

    ^ self behaviorStrategy referencedBehaviors
!

referencedPackages

    ^ self behaviorStrategy referencedPackages
!

removeClassVariable: anRGInstanceVariableDefinition

    ^ self behaviorStrategy removeClassVariable: anRGInstanceVariableDefinition
!

removeSharedPool: anRGPoolVariable

    ^ self behaviorStrategy removeSharedPool: anRGPoolVariable
!

sharedPools

    ^ self behaviorStrategy sharedPools
!

sharedPools: aCollectionOfSymbols

    ^ self behaviorStrategy sharedPools: aCollectionOfSymbols
!

sharedPoolsDo: aBlock

    ^ self behaviorStrategy sharedPoolsDo: aBlock
!

sibling

    ^ self behaviorStrategy sibling
!

traitTransformationString

    ^ self behaviorStrategy traitTransformationString
! !

!RGBehaviorStrategyUser methodsFor:'testing'!

isClass

    ^ self behaviorStrategy isClass
!

sharedPoolNames

    ^ self behaviorStrategy sharedPoolNames
! !

!RGBehaviorStrategyUser methodsFor:'testing class hierarchy'!

kindOfSubclass

    ^ self behaviorStrategy kindOfSubclass
! !

!RGBehaviorStrategyUser methodsFor:'testing types'!

isMetaclass

    ^ self behaviorStrategy isMetaclass
!

isMetaclassTrait

    ^ self behaviorStrategy isMetaclassTrait
! !

!RGBehaviorStrategyUser methodsFor:'variables'!

trait

    "Because of API compatibility between traits and trait transformations"

    ^ self behaviorStrategy trait
! !

!RGBehaviorStrategyUser methodsFor:'visiting'!

acceptVisitor: aVisitor 
    
    ^ self behaviorStrategy acceptVisitor: aVisitor
! !

