"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGEnvironmentBackend subclass:#RGReadOnlyBackend
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Environment'
!

RGReadOnlyBackend comment:''
!

!RGReadOnlyBackend class methodsFor:'as yet unclassified'!

for: anRGEnvironment

    ^ self new 
        environment: anRGEnvironment;
        yourself.
! !

!RGReadOnlyBackend methodsFor:'as yet unclassified'!

readOnlyError

    self error: 'read-only environment'
! !

!RGReadOnlyBackend methodsFor:'behavior'!

addLocalMethod: anRGMethod to: anRGBehavior

    self readOnlyError.
!

addProtocol: anRGProtocolDefinition to: anRGBehavior

    self readOnlyError.
!

cleanLocalMethodsFor: anRGBehavior

    self readOnlyError.
!

cleanProtocolsFor: anRGBehavior

    self readOnlyError.
!

removeLocalMethod: anRGMethod from: anRGBehavior

    self readOnlyError.
!

removeProtocol: anRGProtocolDefinition from: anRGBehavior

    self readOnlyError.
!

setLayoutFor: anRGBehavior to: anRGLayout

    self readOnlyError.
!

setSuperclassFor: anRGBehavior to: anObject

    self readOnlyError.
! !

!RGReadOnlyBackend methodsFor:'class'!

addClassVariable: anRGInstanceVariableDefinition to: anRGBehavior

    self readOnlyError.
!

addMethodTag: aSymbol to: anRGBehavior

    self readOnlyError.
!

addSharedPool: anRGPoolVariable to: anRGBehavior

    self readOnlyError.
!

cleanClassTagsFor: anRGBehavior

    self readOnlyError.
!

cleanClassVariablesFor: anRGBehavior

    self readOnlyError.
!

cleanSharedPoolsFor: anRGBehavior

    self readOnlyError.
!

removeClassVariable: anRGInstanceVariableDefinition from: anRGBehavior

    self readOnlyError.
!

removeMethodTag: aSymbol from: anRGBehavior

    self readOnlyError.
!

removeSharedPool: anRGPoolVariable from: anRGBehavior

    self readOnlyError.
!

setCommentFor: anRGBehavior to: anRGComment

    self readOnlyError.
!

setPackageFor: anRGBehavior to: anRGPackageDefinition

    self readOnlyError.
!

tagClass: anRGBehavior with: aSymbol

    self readOnlyError.
!

tagMethod: anRGMethod with: aSymbol

    self readOnlyError.
!

untagClass: anRGBehavior from: aSymbol

    self readOnlyError.
! !

!RGReadOnlyBackend methodsFor:'class comment'!

setClassCommentAuthorFor: anRGComment to: aString

    self readOnlyError.
!

setClassCommentContentFor: anRGComment to: anObject

    self readOnlyError.
!

setClassCommentTimeFor: anRGComment to: aDateAndTime

    self readOnlyError.
! !

!RGReadOnlyBackend methodsFor:'class description'!

addInstanceVariable: anRGInstanceVariableDefinition to: anRGBehavior

    self readOnlyError.
!

cleanInstanceVariablesFor: anRGBehavior

    self readOnlyError.
!

removeInstanceVariable: anRGInstanceVariableDefinition from: anRGBehavior

    self readOnlyError.
!

setMetaClassFor: anRGBehavior to: anRGMetaclass

    self readOnlyError.
! !

!RGReadOnlyBackend methodsFor:'environment'!

addBehavior: anRGBehavior to: anRGEnvironment

    self readOnlyError.
!

addGlobalVariable: anRGGlobalVariable to: anRGEnvironment

    self readOnlyError.
!

addPackage: anRGPackageDefinition to: anRGEnvironment

    self readOnlyError.
!

cleanBehaviorsFor: anRGEnvironment

    self readOnlyError.
!

cleanGlobalVariablesFor: anRGEnvironment

    self readOnlyError.
!

cleanPackagesFor: anRGEnvironment

    self readOnlyError.
!

removeBehavior: anRGBehavior from: anRGEnvironment

    self readOnlyError.
!

removeGlobalVariable: anRGGlobalVariable from: anRGEnvironment

    self readOnlyError.
!

removePackage: anRGPackageDefinition from: anRGEnvironment

    self readOnlyError.
! !

!RGReadOnlyBackend methodsFor:'general'!

setNameFor: anRGObject to: aString

    self readOnlyError.
! !

!RGReadOnlyBackend methodsFor:'metaclass'!

setBaseClassFor: anRGBehavior to: anRGClass

    self readOnlyError.
! !

!RGReadOnlyBackend methodsFor:'method'!

cleanMethodTagsFor: anRGMethod

    self readOnlyError.
!

cleanTagsForMethodsFor: anRGBehavior

    self readOnlyError.
!

setMethodPackageFor: anRGMethod to: anRGPackageDefinition

    self readOnlyError.
!

setMethodStampFor: anRGMethod to: anObject

    self readOnlyError.
!

setProtocolFor: anRGMethod to: anObject

    self readOnlyError.
!

setSourceCodeFor: anRGMethod to: anObject

    self readOnlyError.
!

untagMethod: anRGMethod from: aSymbol

    self readOnlyError.
! !

!RGReadOnlyBackend methodsFor:'package'!

addClassTag: aSymbol to: anRGPackageDefinition

    self readOnlyError.
!

addDefinedBehavior: anRGBehavior to: anRGPackage

    self readOnlyError.
!

addExtensionMethod: anRGMethod to: anRGPackageDefinition

    self readOnlyError.
!

cleanDefinedBehaviorsFor: anRGPackage

    self readOnlyError.
!

cleanExtensionMethodsFor: anRGPackage

    self readOnlyError.
!

cleanTagsForClassesFor: anRGPackage

    self readOnlyError.
!

removeClassTag: aSymbol from: anRGPackageDefinition

    self readOnlyError.
!

removeDefinedBehavior: anRGBehavior from: anRGPackage

    self readOnlyError.
!

removeExtensionMethod: anRGMethod from: anRGPackage

    self readOnlyError.
! !

!RGReadOnlyBackend methodsFor:'pointer layout'!

addSlot: anRGSlot to: anRGLayout

    self readOnlyError 
!

cleanSlotsFor: anRGLayout

    self readOnlyError 
!

removeSlot: anRGSlot from: anRGLayout

    self readOnlyError 
! !

!RGReadOnlyBackend methodsFor:'slot'!

setExpressionFor: anRGUnknownSlot to: aString

    self readOnlyError
! !

!RGReadOnlyBackend methodsFor:'trait'!

setClassTraitFor: anRGTrait to: anRGMetatraitDefinition

    self readOnlyError 
!

setTraitCommentFor: anRGBehavior to: anRGComment

    self readOnlyError 
!

setTraitPackageFor: anRGBehavior to: anRGPackageDefinition

    self readOnlyError 
! !

!RGReadOnlyBackend methodsFor:'trait alias'!

addAlias: aSymbol to: anRGTraitAlias

    self readOnlyError 
!

cleanAliasesFor: anRGTraitAlias

    self readOnlyError 
!

removeAlias: aSymbol from: anRGTraitAlias

    self readOnlyError 
! !

!RGReadOnlyBackend methodsFor:'trait composition'!

addTransformation: anRGTraitTransformation to: anRGTraitComposition

    self readOnlyError 
!

cleanTransformationsFor: anRGTraitComposition

    self readOnlyError 
!

removeTransformation: anRGTraitTransformation from: anRGTraitComposition

    self readOnlyError 
! !

!RGReadOnlyBackend methodsFor:'trait exclusion'!

addExclusion: aSymbol to: anRGTraitExclusion

    self readOnlyError 
!

cleanExclusionsFor: anRGTraitExclusion

    self readOnlyError 
!

removeExclusion: aSymbol from: anRGTraitExclusion

    self readOnlyError 
! !

!RGReadOnlyBackend methodsFor:'trait transormation'!

setSubjectFor: anRGTraitComposition to: anRGTrait

    self readOnlyError 
! !

!RGReadOnlyBackend methodsFor:'unresolved objects'!

createNewUnresolvedClass

    self readOnlyError 
"	| unresolvedValue |
    
    unresolvedValue := RGUnresolvedValue new.
    unresolvedValue default: unresolvedValue.
    ^ unresolvedValue."
!

createNewUnresolvedMetaclassFor: anRGBehavior

    self readOnlyError 
    "^ RGUnresolvedValue recursive"
!

createNewUnresolvedMetaclassMetaclassFor: anRGBehavior

    self readOnlyError 
    "| unresolvedValue |
    
    unresolvedValue := RGUnresolvedValue new.
    unresolvedValue default: unresolvedValue.
    ^ unresolvedValue."
! !

