"{ Package: 'stx:goodies/ring/core' }"!

!Class methodsFor:'*Ring-Core'!

asRingMinimalCommentDefinitionIn: anRGEnvironment

    ^ anRGEnvironment backend definitionFor: ('classComment:', self name) asSymbol ifAbsentRegister: [
        RGComment parent: (self asRingMinimalDefinitionIn: anRGEnvironment).
    ]. 
    
! !

!Class methodsFor:'*Ring-Core'!

asRingMinimalDefinitionIn: anRGEnvironment

    ^ anRGEnvironment backend definitionFor: self ifAbsentRegister: [
        RGClass named: self name asSymbol parent: anRGEnvironment]. 
    
! !

!Class methodsFor:'*Ring-Core'!

ensureRingDefinitionIn: anRGEnvironment

    ^ anRGEnvironment ask behaviors 
        detect: [:each | each name = self name] 
        ifNone: [ 
            | behaviorModel |
            behaviorModel := self asRingMinimalDefinitionIn: anRGEnvironment.
            anRGEnvironment addBehavior: behaviorModel.
            behaviorModel]
! !

!Metaclass methodsFor:'*Ring-Core'!

asRingMinimalDefinitionIn: anRGEnvironment

    ^ RGMetaclass named: self name parent: anRGEnvironment.
! !

!Method methodsFor:'*Ring-Core'!

asRingMinimalDefinitionIn: anRGEnvironment

    ^ anRGEnvironment backend definitionFor: self ifAbsentRegister: [
        RGMethod named: self selector asSymbol parent: (self methodClass asRingMinimalDefinitionIn: anRGEnvironment)]
! !

!Method methodsFor:'*Ring-Core'!

ensureRingDefinitionIn: anRGEnvironment

    | parentModel |
    
    parentModel := (self methodClass ensureRingDefinitionIn: anRGEnvironment).
    
    ^ parentModel methods 
        detect: [:each | each selector = self selector]
        ifNone: [ 
            | methodModel |
            methodModel := self asRingMinimalDefinitionIn: anRGEnvironment.
            parentModel addLocalMethod: methodModel.
            methodModel ]	
! !

!Object methodsFor:'*Ring-Core'!

isRGObject

    ^ false
! !

!Object methodsFor:'*Ring-Core'!

isRGUnresolvedValue

    ^ false
! !

!Object methodsFor:'*Ring-Core'!

isRingFullyResolved

    ^ true
! !

!Object methodsFor:'*Ring-Core'!

isRingFullyUnresolved

    ^ false
! !

!Object methodsFor:'*Ring-Core'!

isRingResolved

    ^ true
! !

!Object methodsFor:'*Ring-Core'!

markAsRingResolved

    "do nothing"
! !

!Object methodsFor:'*Ring-Core'!

orDefaultForUnresolved

    ^ self
! !

!stx_goodies_ring_core class methodsFor:'documentation'!

extensionsVersion_HG

    ^ '$Changeset: <not expanded> $'
! !
