"{ Package: 'stx:goodies/ring/core/tests' }"

"{ NameSpace: Smalltalk }"

RGTest subclass:#RGClassVariableTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Tests-Core'
!

RGClassVariableTest comment:''
!

!RGClassVariableTest methodsFor:'tests'!

testClassVariableImplicitEnvironment

    | classVariable |
    
    classVariable := RGClassVariable unnamed.
    self assert: (classVariable hasResolvedName not).
    self checkImplicitSingleClassEnvironmentOf: classVariable parent.
    
    classVariable := RGClassVariable named: #SomeClassVariable.
    self assert: (classVariable hasResolvedName).
    self checkImplicitSingleClassEnvironmentOf: classVariable parent.
    
    
    
!

testNewClassVariable

    | classVariable | 
    classVariable  := RGClassVariable unnamed.
    self assert: (classVariable isRingResolved).
    self assert: (classVariable hasUnresolved: #name).
    self assert: (classVariable isVariable).
    self assert: (classVariable isClassVariable).	
    self deny: (classVariable isPoolVariable).	

    classVariable  := RGClassVariable named: #SomeClassVariable.
    self assert: (classVariable isRingResolved).
    self assert: (classVariable hasResolvedAll: #(name)).
    self assert: classVariable name equals: #SomeClassVariable.
    self assert: (classVariable isClassVariable).
    self assert: (classVariable isClassVariable).	
    
!

testResolvingConsistency

    | anObject |
    anObject := RGClassVariable unnamed.
    self checkClassesConsistency: anObject and: anObject makeResolved
! !

