"{ Package: 'stx:goodies/ring/tooling' }"!

!RGBehavior methodsFor:'accessing - stx specific'!

allSubclasses
    ^ self subclasses

    "Created: / 23-12-2020 / 15:32:04 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

allSubclassesDo:aBlock
    self subclasses do: aBlock

    "Created: / 23-12-2020 / 15:25:51 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

allSuperclassesDo:aBlock
    | cls |

    cls := self superclass.

    cls notNil ifTrue: [ 
        cls withAllSuperclassesDo: aBlock
    ].

    "Created: / 23-12-2020 / 15:03:08 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

basicFileOutDefinitionOn:stream withNameSpace:withNamespace withPackage:withPackage
    stream nextPutAll: self definition withTabsExpanded

    "Created: / 23-12-2020 / 15:35:53 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

commentOrDocumentationString
    ^ nil

    "Created: / 29-01-2021 / 19:03:33 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

commonSuperclass:anRGBehavior
    (anRGBehavior == self) ifTrue:[^ self].
    (anRGBehavior isSubclassOf:self) ifTrue:[^ self].
    (self isSubclassOf:anRGBehavior) ifTrue:[^ anRGBehavior].
    superclass isNil ifTrue:[^ nil].
    ^ superclass commonSuperclass:anRGBehavior     

    "Created: / 23-12-2020 / 15:39:44 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

hasExtensions
    ^ false

    "Created: / 23-12-2020 / 15:01:25 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

iconInBrowserSymbol
    ^ nil

    "Created: / 23-12-2020 / 15:02:52 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

instAndClassMethodsDo:aBlock
    self theNonMetaclass localMethodsDo:aBlock.
    self theMetaclass  localMethodsDo:aBlock.

    "Created: / 23-12-2020 / 15:10:57 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

instAndClassSelectorsAndMethodsDo:aBlock
    self instAndClassMethodsDo: [:method| aBlock value: method name value: method ]

    "Created: / 23-12-2020 / 15:05:28 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

isAbstract
    ^ false

    "Created: / 23-12-2020 / 15:00:30 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

isLoaded
    ^ true

    "Created: / 23-12-2020 / 15:00:12 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

isObsolete
    ^ false

    "Created: / 23-12-2020 / 15:01:44 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

isPrivate
    ^  false

    "Created: / 23-12-2020 / 15:04:54 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

isStartableWithMain
    ^ false

    "Created: / 23-12-2020 / 15:14:53 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

isStartableWithStart
    ^ false

    "Created: / 23-12-2020 / 15:15:08 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

isSubclassOf:anRGBehavior
    self allSuperclassesDo: [ :superclass |
        "we are testing name here, because the class 
        can be from another namespace"
        ((superclass name) = (anRGBehavior name)) ifTrue: [ 
            ^ true
        ]
    ].
    ^ false

    "Created: / 23-12-2020 / 15:37:50 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

isUtilityClass
    ^ false

    "Created: / 23-12-2020 / 15:04:02 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

isVisualStartable
    ^ false

    "Created: / 23-12-2020 / 15:14:32 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

methodDictionary
    | md |

    md := Dictionary new.
    self localMethodsDo:[:each | md at: each name put: each ].
    ^ md.

    "Created: / 23-12-2020 / 15:19:23 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

methodsCount
    ^ self localMethods size

    "Created: / 23-12-2020 / 15:00:48 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

nameInBrowser
    ^ self name

    "Created: / 23-12-2020 / 14:59:47 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

owningClass
    ^ nil

    "Created: / 23-12-2020 / 15:08:40 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

privateClassesAt:aString
    ^ nil

    "Created: / 23-12-2020 / 15:36:49 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

programmingLanguage
    ^ SmalltalkLanguage instance

    "Created: / 23-12-2020 / 15:12:35 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

revision
    ^ nil

    "Created: / 23-12-2020 / 15:24:29 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

revisionInfo
    ^ nil

    "Created: / 23-12-2020 / 15:18:49 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

selectorsAndMethodsDo: aBlock
    self localMethodsDo:[:method| aBlock value: method name value: method ]

    "Created: / 23-12-2020 / 15:08:06 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

soleInstance
    ^ self theNonMetaclass

    "Created: / 23-12-2020 / 15:15:43 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

subclassDefinerClass
    ^ nil

    "Created: / 23-12-2020 / 15:35:27 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

supportsMethodCategories
    ^ true

    "Created: / 23-12-2020 / 15:12:22 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

syntaxHighlighterClass
    ^ self programmingLanguage syntaxHighlighterClass.

    "Created: / 23-12-2020 / 15:14:11 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

theMetaclass
    self behaviorStrategy isClassStrategy 
        ifTrue: [ ^ self metaclass ]
        ifFalse:[ ^ self ]

    "Created: / 23-12-2020 / 14:58:43 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

theNonMetaclass
    self behaviorStrategy isClassStrategy ifTrue: [ ^ self ].
    ^ self environment ask behaviorNamed: (self name copyTo: (self name size - ' class' size))

    "Created: / 23-12-2020 / 14:55:17 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

topNameSpace
    ^ self environment

    "Created: / 23-12-2020 / 15:37:02 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

wasAutoloaded
    ^ false

    "Created: / 23-12-2020 / 15:24:50 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

whichClassIncludesSelector: aSymbol
    (self includesSelector:aSymbol) ifTrue:[
        ^ self
    ].
    self superclass notNil ifTrue: [
        ^ self superclass whichClassIncludesSelector:aSymbol
    ].
    ^ nil

    "Created: / 23-12-2020 / 15:31:02 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

withAllSuperclasses
    ^ Array streamContents: [:s | self withAllSuperclassesDo: [:e | s nextPut: e] ]

    "Created: / 23-12-2020 / 15:09:58 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGBehavior methodsFor:'accessing - stx specific'!

withAllSuperclassesDo:aBlock
    "evaluate aBlock for the class and all of its superclasses"

    aBlock value:self.
    self allSuperclassesDo:aBlock

    "Created: / 23-12-2020 / 15:01:58 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGEnvironment methodsFor:'*Powerlang-Core'!

allClasses
    | classes |
    
    classes := OrderedCollection new.
    self behaviorsDo:[:class | class isMeta ifFalse:[classes add: class]].
    classes sort:[:a :b | a name < b name ].
    ^classes
! !

!RGEnvironment methodsFor:'accessing - stx specific'!

allClassesDo:aBlock
    self allClasses do: aBlock

    "Created: / 23-12-2020 / 15:04:23 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGEnvironment methodsFor:'accessing'!

at: aSymbol

        ^ self ask behaviorNamed: aSymbol

    "Created: / 29-01-2021 / 10:17:55 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGEnvironment methodsFor:'accessing - stx specific'!

hasNameSpaces
    ^ false

    "Created: / 23-12-2020 / 15:05:08 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

breakpointsDo:aBlock
    "Nothing"

    "Created: / 23-12-2020 / 15:29:22 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

byteCode
    ^ nil

    "Created: / 23-12-2020 / 15:42:20 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

comment
    ^ nil

    "Created: / 29-01-2021 / 19:05:01 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

getMclass
    ^ self mclass

    "Created: / 23-12-2020 / 15:32:58 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

hasAnnotation
    ^ false

    "Created: / 29-01-2021 / 19:05:20 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

isBreakpointed
    ^ false

    "Created: / 23-12-2020 / 15:29:45 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

isDocumentationMethod
    ^ false

    "Created: / 23-12-2020 / 15:20:46 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

isIgnored
    ^ false

    "Created: / 23-12-2020 / 15:28:30 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

isInstrumented
    ^ false

    "Created: / 23-12-2020 / 15:12:06 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

isObsolete
    ^ false

    "Created: / 23-12-2020 / 15:20:57 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

isPrivate
    ^ false

    "Created: / 23-12-2020 / 15:28:20 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

isProtected
    ^ false

    "Created: / 23-12-2020 / 15:28:10 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

isSynthetic
    ^ false

    "Created: / 23-12-2020 / 15:25:01 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

isVersionMethod
    ^ false.

    "Created: / 23-12-2020 / 15:20:31 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

isWrapped
    ^ false

    "Created: / 23-12-2020 / 15:25:25 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

mclass
    ^ self parent

    "Created: / 23-12-2020 / 15:28:42 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

messagesSentToSelf
    ^ #()

    "Created: / 23-12-2020 / 15:41:34 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

messagesSentToSuper
    ^ #()

    "Created: / 23-12-2020 / 15:41:52 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

previousVersionCode
    ^ nil

    "Created: / 23-12-2020 / 15:42:06 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

printStringForBrowserWithSelector:aSymbol inClass:anRGBehavior
    ^ aSymbol

    "Created: / 23-12-2020 / 15:26:56 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

programmingLanguage
    ^ SmalltalkLanguage instance

    "Created: / 23-12-2020 / 15:28:58 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

resources
    ^ #()

    "Created: / 23-12-2020 / 15:27:32 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

sendsAnySelector:anImmutableArray
    ^ false

    "Created: / 23-12-2020 / 15:37:22 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

source
    ^ self sourceCode

    "Created: / 23-12-2020 / 15:33:25 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

superMessages
    ^ #()

    "Created: / 29-01-2021 / 19:04:43 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

syntaxHighlighterClass
    ^ self programmingLanguage syntaxHighlighterClass

    "Created: / 23-12-2020 / 15:33:48 / Jan Vrany <jan.vrany@labware.com>"
! !

!RGMethod methodsFor:'accessing - stx specific'!

wrapper
    ^ nil

    "Created: / 23-12-2020 / 15:29:59 / Jan Vrany <jan.vrany@labware.com>"
! !

!stx_goodies_ring_tooling class methodsFor:'documentation'!

extensionsVersion_HG

    ^ '$Changeset: <not expanded> $'
! !
